--- /dev/null	2007-08-19 10:55:00.000000000 +0200
+++ vm/vm_reserv.c	2007-08-19 10:58:32.000000000 +0200
@@ -0,0 +1,788 @@
+/*-
+ * Copyright (c) 2002-2006 Rice University
+ * All rights reserved.
+ *
+ * This software was developed for the FreeBSD Project by Alan L. Cox,
+ * Olivier Crameri, Peter Druschel, Sitaram Iyer, and Juan Navarro.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/*
+ *	Superpage reservation management module
+ */
+
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
+#include "opt_vm.h"
+
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/lock.h>
+#include <sys/malloc.h>
+#include <sys/mutex.h>
+#include <sys/queue.h>
+#include <sys/sbuf.h>
+#include <sys/sysctl.h>
+#include <sys/systm.h>
+
+#include <vm/vm.h>
+#include <vm/vm_param.h>
+#include <vm/vm_object.h>
+#include <vm/vm_page.h>
+#include <vm/vm_phys.h>
+#include <vm/vm_reserv.h>
+
+/* 
+ * Returns the index of the reservation in which the page is located. This index refers
+ * to a reservation of size res->level - 1 (i.e res->order - SP_FACTOR_SHIFT)
+ */
+#define IDX(m,res) (((m) - (res)->first_page) >> \
+					((res)->order - SP_FACTOR_SHIFT))
+
+#define NO_RESQ		SP_LEVELS		/*reserv->rql==NO_RESQ -> reservation is in no reservation queue */
+
+static vm_reserv_t vm_reserv_alloc(void);
+static vm_reserv_t vm_reserv_create(int, vm_object_t);
+static void vm_reserv_create_children(vm_reserv_t, vm_page_t);
+static void vm_reserv_dequeue(vm_reserv_t);
+static void vm_reserv_free(vm_reserv_t);
+static void vm_reserv_move(vm_reserv_t, boolean_t);
+static int vm_reserv_policy(vm_object_t, vm_pindex_t, int);
+static void vm_reserv_update_maxavail(vm_reserv_t);
+
+/*
+ * Reservations in rres[level], with level=-1..SP_LEVELS-2, are those that, 
+ * if broken, will yield chunks of size at most SP_MAGN(level).
+ * Fully populated reservations don't go here
+ */
+static struct vm_reserv_queue rres_store[SP_LEVELS];
+static struct vm_reserv_queue *const rres = &rres_store[1];
+static struct mtx rres_mtx;
+
+/*
+ * The free reservation queue:
+ */
+static struct vm_reserv_queue vm_resq_free;
+static struct mtx vm_resq_free_mtx;
+static int vm_resq_free_count;
+
+SYSCTL_NODE(_vm, OID_AUTO, reserv, CTLFLAG_RD, 0, "Reservation Info");
+
+SYSCTL_INT(_vm_reserv, OID_AUTO, free, CTLFLAG_RD, &vm_resq_free_count, 0,
+    "Free Reservations");
+
+static int sysctl_vm_reserv_queues(SYSCTL_HANDLER_ARGS);
+
+SYSCTL_OID(_vm_reserv, OID_AUTO, queues, CTLTYPE_STRING | CTLFLAG_RD,
+    NULL, 0, sysctl_vm_reserv_queues, "A", "Reservation Queues");
+
+/*
+ *
+ */
+static int
+sysctl_vm_reserv_queues(SYSCTL_HANDLER_ARGS)
+{
+	vm_reserv_t res;
+	struct sbuf sbuf;
+	char *cbuf;
+	const int cbufsize = (SP_LEVELS + 1) * 81;
+	int counter, error, level;
+
+	cbuf = malloc(cbufsize, M_TEMP, M_WAITOK | M_ZERO);
+	sbuf_new(&sbuf, cbuf, cbufsize, SBUF_FIXEDLEN);
+	sbuf_printf(&sbuf, "\nLEVEL     SIZE  NUMBER\n\n");
+	for (level = -1; level <= SP_LEVELS - 2; level++) {
+		counter = 0;
+		mtx_lock(&rres_mtx);
+		TAILQ_FOREACH(res, &rres[level], next)
+			counter++;
+		mtx_unlock(&rres_mtx);
+		sbuf_printf(&sbuf, "%5.5d: %6.6dK, %6.6d\n", level,
+		    SP_SIZE(level) / 1024, counter);
+	}
+	sbuf_finish(&sbuf);
+	error = SYSCTL_OUT(req, sbuf_data(&sbuf), sbuf_len(&sbuf));
+	sbuf_delete(&sbuf);
+	free(cbuf, M_TEMP);
+	return (error);
+}
+
+/*
+ * Determine the size of the reservation to create for the given
+ * vm_object
+ * Returns the level of the reservation corresponding to the reservation size
+ */
+static int
+vm_reserv_policy(vm_object_t object, vm_pindex_t pindex, int level)
+{
+
+	VM_OBJECT_LOCK_ASSERT(object, MA_OWNED);
+
+	/* 
+	 * If vnode or backed by vnode, do not reserve beyond object's size.
+	 * We don't bother looking too far in the object chain.
+	 */
+	if (object->type == OBJT_VNODE || (object->backing_object != NULL &&
+	    object->backing_object->type == OBJT_VNODE))
+		while (level >= 0 && object->size < pindex -
+		    SP_POS(object, pindex, level) + SP_MAGN(level))
+			level--;
+	KASSERT(level >= -1, ("vm_reserv_policy: invalid level"));
+	return (level);
+}
+
+/*
+ * Update maxavail in the given superpage reservation and each of its
+ * ancestors.  As a side effect, free any unused descendants of these
+ * superpage reservations.
+ */
+static void
+vm_reserv_update_maxavail(vm_reserv_t res)
+{
+	vm_reserv_t child;
+	int i, newmax;
+	boolean_t nochild;
+
+	VM_OBJECT_LOCK_ASSERT(res->object, MA_OWNED);
+	res->maxavail = MAX(res->popfrom, (1 << res->order) - res->popto);
+	while ((res = res->parent) != NULL) {	
+		KASSERT(!res->broken,
+		    ("vm_reserv_update_maxavail: reservation %p is broken", res));
+		newmax = 0;
+		nochild = TRUE;
+		for (i = 0; i < SP_FACTOR; i++) {
+			child = res->child[i];
+			if (child != NULL && child->popfrom == child->popto) {
+				KASSERT(child->refcnt == 0,
+				    ("vm_reserv_update_maxavail: child->refcnt != 0"));
+				vm_reserv_free(child);
+				child = res->child[i] = NULL;
+			}
+			if (child == NULL)
+				newmax = 1 << (res->order - SP_FACTOR_SHIFT);
+			else {
+				newmax = MAX(newmax, child->maxavail);
+				nochild = FALSE;
+			}
+		}
+		if (nochild) {
+			/* must have been marked */
+			KASSERT(res->popfrom > res->popto,
+			    ("vm_reserv_update_maxavail: popfrom <= popto"));
+			res->popfrom = res->popto = 0;
+			res->maxavail = 1 << res->order;
+		} else {
+			if (newmax == res->maxavail)
+				break;
+			res->maxavail = newmax;
+		}
+	}
+}
+
+/*
+ * Acquire a reservation for the given object and offset. 
+ */
+vm_reserv_t
+vm_reserv_acquire(vm_object_t object, vm_pindex_t pindex, int req)
+{
+	int l, level;
+	vm_page_t m, p, s;
+	vm_pindex_t first, leftcap, rightcap;
+	vm_reserv_t res;
+
+	VM_OBJECT_LOCK_ASSERT(object, MA_OWNED);
+	if ((object->flags & OBJ_SUPERPAGES) == 0 || pindex >= object->size)
+		return (NULL);
+
+	/*
+	 * Look for an existing reservation.
+	 */
+	s = NULL;
+	p = object->root;
+	while (p != NULL) {
+		KASSERT(p->pindex != pindex,
+		    ("vm_reserv_acquire: pindex already allocated"));
+		res = vm_reserv_get(p);
+		if (res != NULL && vm_reserv_has_pindex(res, pindex))
+			return (res);
+		else if (p->pindex < pindex) {
+			if (s != NULL || (s = TAILQ_NEXT(p, listq)) == NULL)
+				break;
+			KASSERT(s->pindex != pindex,
+			    ("vm_reserv_acquire: pindex already allocated"));
+			res = vm_reserv_get(s);
+			if (res != NULL && vm_reserv_has_pindex(res, pindex))
+				return (res);
+			else if (pindex < s->pindex)
+				break;
+		} else if (s == NULL) {
+			s = p;
+			p = TAILQ_PREV(s, pglist, listq);
+			continue;
+		}
+		s = NULL;
+		p = object->root = vm_page_splay(pindex, object->root);
+	}
+
+	/*
+	 * Determine the first index to the left that can be used.
+	 */
+	if (p == NULL)
+		leftcap = 0;
+	else if (p->reserv == NULL)
+		leftcap = p->pindex + 1;
+	else
+		leftcap = p->reserv->first_pindex + SP_MAGN(p->reserv->level);
+
+	/*
+	 * Determine the first index to the right that cannot be used.
+	 */
+	if (s == NULL)
+		rightcap = pindex + SP_LARGE;
+	else if (s->reserv == NULL)
+		rightcap = s->pindex;
+	else
+		rightcap = s->reserv->first_pindex;
+
+	/*
+	 * Determine the level of the largest superpage that fits
+	 * between leftcap and rightcap.
+	 */
+	for (l = 0; l < SP_LEVELS; l++) {
+		if (pindex < SP_POS(object, pindex, l))
+			break;
+		first = pindex - SP_POS(object, pindex, l);
+		if (first < leftcap || first + SP_MAGN(l) > rightcap)
+			break;
+	}
+	l--;
+	KASSERT(l >= -1 && l < SP_LEVELS,
+	    ("vm_reserv_acquire: invalid level"));
+	level = vm_reserv_policy(object, pindex, l);
+	for (; level > -1; level--) {
+retry:
+		mtx_lock(&vm_page_queue_free_mtx);
+		if (cnt.v_free_count > cnt.v_free_reserved + SP_MAGN(level)) {
+			m = vm_phys_alloc_pages_locked(VM_FREEPOOL_RESERV,
+			    SP_ORDER(level));
+			mtx_unlock(&vm_page_queue_free_mtx);
+			if (m != NULL) {
+				res = vm_reserv_create(level, object);
+				res->first_page = m;
+				res->first_pindex = pindex - SP_POS(object,
+				    pindex, level);
+				return (res);
+			}
+		} else
+			mtx_unlock(&vm_page_queue_free_mtx);
+		if (level < SP_LEVELS - 1 && vm_reserv_reclaim(level))
+			goto retry;
+	}
+	return (NULL);
+}
+
+/*
+ * Returns the superpage reservation containing the given page. 
+ */
+vm_reserv_t
+vm_reserv_lookup(vm_page_t m)
+{
+	vm_reserv_t res;
+
+	while ((res = m->reserv) != NULL && __predict_false(res->broken)) {
+		m->reserv = res->child[IDX(m, res)];
+		KASSERT(res->refcnt > 0,
+		    ("vm_reserv_lookup: reservation %p has"
+		    " an invalid refcnt", res));
+		res->refcnt--;
+		if (res->refcnt == 0)
+			vm_reserv_free(res);
+	}	
+	return (res);
+}
+
+static long vm_reserv_allocations;
+SYSCTL_LONG(_vm_reserv, OID_AUTO, allocations, CTLFLAG_RD,
+    &vm_reserv_allocations, 0, "");
+
+/*
+ * Allocates a superpage reservation.  Initializes all of its fields
+ * to zero.  Always returns a superpage reservation; never fails.
+ */
+static vm_reserv_t
+vm_reserv_alloc(void)
+{
+	vm_reserv_t res;
+
+	vm_reserv_allocations++;
+	mtx_lock(&vm_resq_free_mtx);
+	res = TAILQ_FIRST(&vm_resq_free);
+	KASSERT(res != NULL,
+	    ("vm_reserv_alloc: free reservation queue is empty"));
+	TAILQ_REMOVE(&vm_resq_free, res, next);
+	vm_resq_free_count--;
+	mtx_unlock(&vm_resq_free_mtx);
+	bzero(res, sizeof(*res));
+	return (res);
+}
+
+/*
+ * Allocates a superpage reservation.  Initializes it to the given
+ * object and level.  Always returns a superpage reservation; never
+ * fails.
+ */
+static vm_reserv_t
+vm_reserv_create(int level, vm_object_t object)
+{
+	vm_reserv_t sp;
+
+	KASSERT(level >= 0, ("vm_reserv_create: invalid level"));
+	sp = vm_reserv_alloc();
+	sp->level = level;
+	sp->order = SP_ORDER(level);
+	sp->rql = NO_RESQ;
+	sp->maxavail = 1 << SP_ORDER(level);
+	sp->object = object;
+	return (sp);
+}
+
+/*
+ * Instantiates the children of the given superpage reservation.
+ */ 
+static void
+vm_reserv_create_children(vm_reserv_t res, vm_page_t m /* NULL => noupdate */)
+{
+	vm_reserv_t ch;
+	int from, idx, magn, to;
+
+	VM_OBJECT_LOCK_ASSERT(res->object, MA_OWNED);
+	magn = 1 << (res->order - SP_FACTOR_SHIFT);
+	idx = res->popfrom >> (res->order - SP_FACTOR_SHIFT);
+	KASSERT(idx >= 0 && idx < SP_FACTOR,
+	    ("vm_reserv_create_children: idx invalid"));
+	for (from = res->popfrom - idx * magn, to = res->popto - idx * magn;
+	    from < to; from = 0, to -= magn, idx++) {
+		ch = res->child[idx];
+		if (ch == NULL) {
+			ch = res->child[idx] = vm_reserv_create(res->level - 1, res->object);
+			ch->parent = res;
+			ch->first_page = &res->first_page[idx * (1 << ch->order)];
+			ch->first_pindex = res->first_pindex + idx * (1 << ch->order);
+			KASSERT(from < magn, ("vm_reserv_create_children: xxx"));
+			ch->popfrom = from;
+			ch->popto = to > magn ? magn : to;
+			ch->refcnt = ch->popto - ch->popfrom;			
+			if (ch->order == SP_SMALL_SHIFT) {
+				/* adjust things */
+				ch->popto = ch->popto - ch->popfrom;
+				ch->popfrom = 0;
+			}
+		}
+
+		/* 
+		 * this is subtle: we update maxavail only if ch is
+		 * not in the path to m. If it is, we don't want to
+		 * update maxavail to ensure propper propagation up.
+		 */
+		if (m == NULL || m < ch->first_page ||
+		    m >= ch->first_page + (1 << ch->order))
+			ch->maxavail = (1 << ch->order) - (ch->popto - ch->popfrom);
+	}
+	/* invalid popfrom/popto as a mark that means "has children" */
+	res->popfrom = 1;
+	res->popto = 0;
+}
+
+/*
+ *
+ */
+static __inline void
+vm_reserv_dequeue(vm_reserv_t sp)
+{
+
+	if (sp->rql != NO_RESQ) {
+		KASSERT(sp->rql >= -1 && sp->rql < SP_LEVELS - 1,
+		    ("vm_reserv_dequeue: sp->rql invalid"));
+		mtx_lock(&rres_mtx);
+		TAILQ_REMOVE(&rres[sp->rql], sp, next);
+		mtx_unlock(&rres_mtx);
+		sp->rql = NO_RESQ;
+	}
+}
+
+/*
+ * Frees a superpage reservation.
+ */
+static void
+vm_reserv_free(vm_reserv_t res)
+{
+
+	mtx_lock(&vm_resq_free_mtx);
+	TAILQ_INSERT_HEAD(&vm_resq_free, res, next);
+	vm_resq_free_count++;
+	mtx_unlock(&vm_resq_free_mtx);
+}
+
+static vm_reserv_t
+follow_child(vm_reserv_t res, int idx)
+{
+	vm_reserv_t ch;
+
+	KASSERT(idx >= 0 && idx < SP_FACTOR, ("follow_child: idx invalid"));
+	if (res->child[idx] == NULL) {
+		ch = vm_reserv_create(res->level - 1, res->object);
+		res->child[idx] = ch;
+		ch->parent = res;
+		ch->first_page = &res->first_page[idx * (1 << ch->order)];
+		ch->first_pindex = res->first_pindex + idx * (1 << ch->order);
+	}
+	return (res->child[idx]);
+}
+
+/*
+ * The given page is used.
+ */
+void
+vm_reserv_populate(vm_page_t m, vm_reserv_t res)
+{
+	int pos;
+
+	VM_OBJECT_LOCK_ASSERT(res->object, MA_OWNED);
+	m->reserv = res;
+	for (;;) {
+		KASSERT(!res->broken,
+		    ("vm_reserv_populate: reservation %p is broken", res));
+		KASSERT(m >= res->first_page &&
+		    m < &res->first_page[1 << res->order],
+		    ("vm_reserv_populate: page %p is outside"
+		    " of reservation %p", m, res));
+		KASSERT(res->refcnt < 1 << res->order,
+		    ("vm_reserv_populate: reservation %p has"
+		    " an invalid refcnt", res));
+		res->refcnt++;
+		if (res->order == SP_SMALL_SHIFT) {
+			/* at this level we just count */
+			KASSERT(res->popto < SP_SMALL,
+			    ("vm_reserv_populate: reservation %p has"
+			    " an invalid popto", res));
+			res->popto++;
+			/* if popto == SP_SMALL we could colapse, but don't bother */
+			break;
+		} else if (res->popfrom == res->popto) {
+			/* first population */
+			pos = m - res->first_page;
+			res->popfrom = pos;
+			res->popto = pos + 1;
+			break;
+		} else if (res->popfrom < res->popto) {
+			pos = m - res->first_page;
+			if (pos == res->popfrom - 1) {
+				res->popfrom--;
+				break;
+			} else if (pos == res->popto) {
+				res->popto++;
+				break;
+			}
+			vm_reserv_create_children(res, m);
+		}
+		res = follow_child(res, IDX(m, res));
+		KASSERT(res != NULL,
+		    ("vm_reserv_populate: missing reservation"));
+	}
+	vm_reserv_update_maxavail(res);
+	vm_reserv_move(m->reserv, TRUE);
+}
+
+/*
+ * The given page is not used.
+ */
+void
+vm_reserv_depopulate(vm_reserv_t res, vm_page_t m)
+{
+	vm_reserv_t sp;
+	int pos;
+
+	VM_OBJECT_LOCK_ASSERT(res->object, MA_OWNED);
+	for (sp = res;;) {
+		KASSERT(!sp->broken,
+		    ("vm_reserv_depopulate: reservation %p is broken", sp));
+		KASSERT(sp->popfrom != sp->popto,
+		    ("vm_reserv_depopulate: reservation %p is empty", sp));
+		KASSERT(sp->refcnt > 0,
+		    ("vm_reserv_depopulate: reservation %p has"
+		    " an invalid refcnt", sp));
+		sp->refcnt--;
+		if (sp->order == SP_SMALL_SHIFT) {
+			/* at this level we just count */
+			KASSERT(sp->popto > 0,
+			    ("vm_reserv_depopulate: reservation %p has"
+			    " an invalid popto", sp));
+			sp->popto--;
+			break;
+		} else if (sp->popfrom < sp->popto) {
+			pos = m - sp->first_page;
+			if (sp->popfrom == pos) {
+				sp->popfrom++;
+				break;
+			} else if (sp->popto == pos + 1) {
+				sp->popto--;
+				break;
+			}
+			vm_reserv_create_children(sp, m);
+		}
+		sp = sp->child[IDX(m, sp)];
+		KASSERT(sp != NULL,
+		    ("vm_reserv_depopulate: missing reservation"));
+	}
+	if (sp->popfrom == sp->popto)
+		sp->popfrom = sp->popto = 0;
+	m->reserv = NULL;
+	vm_reserv_update_maxavail(sp);
+	vm_reserv_move(res, FALSE);
+}
+
+/*
+ * Initializes the superpage reservation system.
+ */
+void
+vm_reserv_init(vm_reserv_t reservation, int nreservations) 
+{
+	int i;
+
+	TAILQ_INIT(&vm_resq_free);
+	for (i = 0; i < nreservations; i++) {
+		TAILQ_INSERT_TAIL(&vm_resq_free, reservation, next);
+		reservation++;
+	}
+	vm_resq_free_count += nreservations;
+	mtx_init(&vm_resq_free_mtx, "free reservation queue", NULL, MTX_DEF);
+	for (i = -1; i < SP_LEVELS - 1; i++)
+		TAILQ_INIT(&rres[i]);
+	mtx_init(&rres_mtx, "reservation queues", NULL, MTX_DEF);
+}
+
+static int vm_reserv_reclamations;
+SYSCTL_INT(_vm_reserv, OID_AUTO, reclamations, CTLFLAG_RD,
+    &vm_reserv_reclamations, 0, "Cumulative number of reclaimed reservations");
+
+/*
+ * Finds a superpage reservation at or above the given level and
+ * releases it.
+ */
+boolean_t
+vm_reserv_reclaim(int level)
+{
+	vm_object_t object;
+	vm_reserv_t sp;
+	int l;
+	boolean_t was_trylocked;
+
+	KASSERT(level >= -1 && level < SP_LEVELS - 1,
+	    ("vm_reserv_reclaim: invalid level")); 	
+	mtx_lock(&rres_mtx);
+	for (l = level; l < SP_LEVELS - 1; l++) {
+		TAILQ_FOREACH(sp, &rres[l], next) {
+			KASSERT(sp->rql == l && sp->rql < sp->level,
+			    ("vm_reserv_reclaim: reservation %p has"
+			    " an invalid rql", sp));
+			object = sp->object;
+			was_trylocked = VM_OBJECT_TRYLOCK(object);
+			if (was_trylocked ||
+			    VM_OBJECT_LOCKED(object)) {
+				TAILQ_REMOVE(&rres[l], sp, next);
+				vm_reserv_reclamations++;
+				mtx_unlock(&rres_mtx);
+				sp->rql = NO_RESQ;
+				vm_reserv_release(sp, level, NULL);
+				if (was_trylocked)
+					VM_OBJECT_UNLOCK(object);
+				return (TRUE);
+			}
+		}
+	}
+	mtx_unlock(&rres_mtx);
+	return (FALSE);
+}
+
+static long vm_reserv_releases;
+SYSCTL_LONG(_vm_reserv, OID_AUTO, releases, CTLFLAG_RD,
+    &vm_reserv_releases, 0, "");
+
+/* 
+ * Frees a chunk of size SP_MAGN(lev) by breaking a reservation,
+ * or, if m!=NULL, break the part of the reservation where m lies.
+ */
+void
+vm_reserv_release(vm_reserv_t sp, int lev, vm_page_t m)
+{
+	int i, magn, recovered = 0;
+	vm_reserv_t ch, nxt, res;
+	vm_page_t p;
+
+	VM_OBJECT_LOCK_ASSERT(sp->object, MA_OWNED);
+	vm_reserv_releases++;
+	if (m) {
+		if (m->reserv->broken) vm_reserv_lookup(m);
+	}
+	KASSERT(sp->popfrom != sp->popto,("preempt: popfrom = popto"));
+	for (; sp != NULL; sp = nxt) {
+		if (sp->rql != NO_RESQ) {
+			/* remove from queue */
+			KASSERT(sp->rql < sp->level && sp->rql >= -1,
+			    ("vm_reserv_release: reservation %p has"
+			    " an invalid rql", sp));
+			mtx_lock(&rres_mtx);
+			TAILQ_REMOVE(&rres[sp->rql], sp, next);
+			mtx_unlock(&rres_mtx);
+			sp->rql = NO_RESQ;
+		}
+		KASSERT(!sp->broken,
+		    ("vm_reserv_release: reservation %p is broken", sp));
+		sp->broken = TRUE;
+		nxt = NULL;
+		if (sp->order == SP_SMALL_SHIFT) {
+			/*
+			 * The reservation sp may be freed before all of its
+			 * pages are freed.  Therefore, a local reference to
+			 * its pages is used within the loop.
+			 */
+			p = sp->first_page;
+			for (i = 0; i < SP_SMALL; i++) {
+				if (p->reserv != NULL) {
+					/* Deallocate the reservation. */
+					res = vm_reserv_lookup(p);
+					KASSERT(res == NULL,
+					    ("vm_reserv_release: deallocation"
+					    " of reservation %p failed", res));
+				} else {
+					vm_phys_free_pages(p, 0);
+					if (recovered < 1)
+						recovered = 1;
+				}
+				p++;
+			}
+		} else {
+			if (sp->popfrom < sp->popto)
+				vm_reserv_create_children(sp, NULL);
+			if (m != NULL) {
+				nxt = sp->child[IDX(m, sp)];
+				KASSERT(nxt != NULL,
+				    ("vm_reserv_release: missing reservation"));
+			}
+			/* put sub-sps back in queues, with some exceptions */
+			for (i = 0; i < SP_FACTOR; i++) {
+				ch = sp->child[i];
+				if (ch == NULL) {
+					magn = 1 << (sp->order - SP_FACTOR_SHIFT);
+					p = &sp->first_page[i * magn];
+					vm_phys_free_pages(p, sp->order - SP_FACTOR_SHIFT);
+					if (recovered < magn)
+						recovered = magn;
+				} else {
+					KASSERT(ch->maxavail < 1 << ch->order,
+					    ("preempt: ch invalid"));
+					ch->parent = NULL;
+					if (nxt == NULL &&
+					    ch->maxavail == sp->maxavail)
+						nxt = ch;
+					else if (ch->maxavail > 0) {
+						KASSERT(ch->popto != ch->popfrom,
+						    ("preempt: ch->popto = ch->popfrom"));
+						ch->rql = logf(ch->maxavail);
+						KASSERT(ch->rql < ch->level,
+						    ("preempt: ch->rql >= ch->level"));
+						mtx_lock(&rres_mtx);
+						TAILQ_INSERT_TAIL(&rres[ch->rql], ch, next);
+						mtx_unlock(&rres_mtx);
+					}
+				}
+			}
+		}
+	}
+	if (!m)
+		KASSERT(recovered >= (lev == -1 ? 1 : SP_MAGN(lev)),
+		    ("preempt: recovered < SP_MAGN(level)"));
+}
+
+/*
+ *
+ */
+static void
+vm_reserv_move(vm_reserv_t sp, boolean_t to_tail)
+{
+	int rql;
+
+	VM_OBJECT_LOCK_ASSERT(sp->object, MA_OWNED);
+	if (sp->maxavail == 0) {
+		/* Full reservation: Dequeue the superpage reservation. */
+		vm_reserv_dequeue(sp);
+	} else if (sp->refcnt == 0) {
+		KASSERT(sp->maxavail == 1 << sp->order,
+		    ("vm_reserv_move maxavail=%d", sp->maxavail));
+		/* Empty reservation: Free the superpage reservation. */
+		vm_reserv_dequeue(sp);
+		vm_phys_free_pages(sp->first_page, sp->order);
+		vm_reserv_free(sp);
+	} else {
+		KASSERT(sp->popto != sp->popfrom,
+		    ("vm_reserv_move: popto = popfrom"));
+
+		/*
+		 * Return if the superpage reservation is already at
+		 * the designated place.  Inaccuracy due to a race is
+		 * of small consequence because the only effect is on
+		 * the order of reclamation.
+		 */
+		rql = logf(sp->maxavail);
+		KASSERT(rql < sp->level,
+		    ("vm_reserv_move: rql >= level: rql: %d, level: %d",
+		    rql, sp->level));
+		if (rql == sp->rql) {
+			if (to_tail) {
+				if (TAILQ_NEXT(sp, next) == NULL)
+					return;
+			} else {
+				if (TAILQ_FIRST(&rres[rql]) == sp)
+					return;
+			}
+		}
+
+		/*
+		 * Move the superpage reservation to the head or the
+		 * tail of the appropriate reservation queue.
+		 */
+		mtx_lock(&rres_mtx);
+		if (sp->rql != NO_RESQ) {
+			KASSERT(sp->rql >= -1 && sp->rql < SP_LEVELS - 1,
+			    ("vm_reserv_move: sp->rql invalid"));
+			TAILQ_REMOVE(&rres[sp->rql], sp, next);
+		}
+		sp->rql = rql;
+		if (to_tail)
+			TAILQ_INSERT_TAIL(&rres[sp->rql], sp, next);
+		else
+			TAILQ_INSERT_HEAD(&rres[sp->rql], sp, next);
+		mtx_unlock(&rres_mtx);
+	}	
+}
--- /dev/null	2007-08-19 10:55:00.000000000 +0200
+++ vm/vm_reserv.h	2007-08-19 10:58:33.000000000 +0200
@@ -0,0 +1,138 @@
+/*-
+ * Copyright (c) 2002-2006 Rice University
+ * All rights reserved.
+ *
+ * This software was developed for the FreeBSD Project by Alan L. Cox,
+ * Olivier Crameri, Peter Druschel, Sitaram Iyer, and Juan Navarro.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * $FreeBSD$
+ */
+
+/*
+ *	Superpage reservation system definitions
+ */
+
+#ifndef	_VM_RESERV_H_
+#define	_VM_RESERV_H_
+
+#include <sys/param.h>
+#include <sys/queue.h>
+
+#include <vm/vm.h>
+
+/* SUPERPAGES:
+ * PAGE_SIZE = 2**PAGE_SHIFT
+ * SMALLEST SUPERPAGE SIZE (level 0) = 2**(PAGE_SHIFT + SMALL_SHIFT)
+ * NEXT SUPERPAGE SIZES (level l) = 2**(PAGE_SHIFT + SMALL_SHIFT + l*SP_FACTOR_SHIFT) 
+ */
+#define	SP_SMALL	(1 << SP_SMALL_SHIFT)
+#define SP_FACTOR	(1 << SP_FACTOR_SHIFT)
+
+#define	SP_MAGN(l)	(SP_SMALL << (SP_FACTOR_SHIFT * (l))) /* magn of level l>=0 */
+#define SP_ORDER(l)	((l) == -1 ? 0 : SP_SMALL_SHIFT + SP_FACTOR_SHIFT * (l))
+#define SP_SIZE(l)	(1 << (SP_ORDER(l) + PAGE_SHIFT))
+
+#define	SP_LARGE	SP_MAGN(SP_LEVELS - 1)
+
+/* position within a superpage of magnitud M */
+#define	SP_POS(object, pindex, level) \
+	    (((object)->pg_color + (pindex)) & (SP_MAGN(level) - 1))
+
+/*
+ * Compute the reservation queue level for a superpage reservation
+ * with maxavail unused pages. 
+ */
+static __inline int
+logf(int maxavail)
+{
+	int i, rql;
+
+	rql = -1;
+	for (i = SP_SMALL_SHIFT; 1 << i < maxavail + 1; i += SP_FACTOR_SHIFT)
+		rql++;
+	return (rql);
+}
+
+struct	vm_reserv {
+	vm_object_t object;	/* Object to which this reservation is tied */
+	vm_pindex_t	first_pindex;
+	vm_page_t	first_page;
+	TAILQ_ENTRY(vm_reserv) next; /* to link reserved superpages */
+
+	/* 
+	 * level is redundant (== (order-SMALL_SHIFT)/SP_FACTOR_SHIFT) and a legacy thing
+	 * With a little work can be eliminated
+	 */
+	signed char level;
+	signed char rql;				/* rres queue level */
+	unsigned char broken;				/* boolean: was this reserv broken? */
+	signed char order;				/* such that size (in base pages) = 1 << order */
+	short popfrom, popto;			/* popfrom > popto iif has children */
+	short refcnt;				/* refcnt == 0 iff popfrom == popto */
+	short maxavail;				/* maxavail == (1 << order) iif refcnt == 0 */
+
+	/* 
+	 * parent is only used to propagate maxavail up; can be replaced
+	 * by a stack of pointers local to a few functions in reserve.c
+	 */
+	vm_reserv_t parent;			
+	vm_reserv_t child[SP_FACTOR];
+};
+
+TAILQ_HEAD(vm_reserv_queue, vm_reserv);
+
+vm_reserv_t	vm_reserv_acquire(vm_object_t, vm_pindex_t, int);
+void		vm_reserv_depopulate(vm_reserv_t, vm_page_t);
+void		vm_reserv_init(vm_reserv_t, int);
+vm_reserv_t	vm_reserv_lookup(vm_page_t);
+void		vm_reserv_populate(vm_page_t, vm_reserv_t);
+boolean_t	vm_reserv_reclaim(int);
+void		vm_reserv_release(vm_reserv_t, int, vm_page_t);
+
+/*
+ * Returns the superpage reservation containing the given page. 
+ */
+static __inline vm_reserv_t
+vm_reserv_get(vm_page_t m)
+{
+	vm_reserv_t reserv;
+
+	reserv = m->reserv;
+	if (reserv != NULL && __predict_false(reserv->broken))
+		reserv = vm_reserv_lookup(m);
+	return (reserv);
+}
+
+/*
+ * Returns TRUE if the given superpage reservation contains the given pindex;
+ * otherwise, returns FALSE.
+ */
+static __inline boolean_t
+vm_reserv_has_pindex(vm_reserv_t reserv, vm_pindex_t pindex)
+{
+
+	return (((pindex - reserv->first_pindex) & ~(SP_MAGN(reserv->level) - 1)) == 0);
+}
+
+#endif	/* !_VM_RESERV_H_ */
